from typing import Generic, TypeVar

from rainbowadn.core import *
from rainbowadn.nullability import *

__all__ = ("CollectionInterface",)

CollectionType = TypeVar("CollectionType", bound=Mentionable, covariant=True)


class CollectionInterface(Generic[CollectionType]):
    def __init__(self, reference: NullableReference[CollectionType]):
        assert isinstance(reference, NullableReference)
        self.reference = reference
