import abc
from typing import Generic, TypeVar

from rainbowadn.core import *

from .comparator import *

__all__ = ("ProtocolComparator",)

KeyType = TypeVar("KeyType", bound=Mentionable, contravariant=True)


class ProtocolComparator(Comparator[KeyType], abc.ABC, Generic[KeyType]):
    def __init__(self, equal: Equal):
        assert isinstance(equal, Equal)
        self.equal = equal
