from typing import TypeVar

from rainbowadn.core import *

from ._flowstandard import *

__all__ = ("flow_union",)

KeyT = TypeVar("KeyT", bound=Mentionable)


async def flow_union(left: FlowStandard[KeyT], right: FlowStandard[KeyT]) -> FlowStandard[KeyT]:
    return FlowStandard((await left.protocolized.tree.union(right.protocolized.tree)).protocolized())
